
joyCons = {
    stickMin = 0.15,
    triggerMin = 0.1,
    stickList = {
        leftx = 0,
        lefty = 0,
        rightx = 0,
        righty = 0,
    },
    triggerList = {
        triggerleft = 0,
        triggerright = 0,
    }
}

function joyMin( axis, value )
    if joyCons.stickList[axis] then axisMin = joyCons.stickMin
    elseif joyCons.triggerList[axis] then axisMin = joyCons.triggerMin end
    if axisMin then
        if math.abs( value ) < axisMin then value = 0 end
    end
    return value
end

function love.joystickadded( joystick )
    joys = joys or {}
    if joystick:isGamepad() then
        local joy = {
            leftx = joyMin( "leftx", joystick:getGamepadAxis( "leftx" ) ),
            lefty = joyMin( "lefty", joystick:getGamepadAxis( "lefty" ) ),
            rightx = joyMin( "rightx", joystick:getGamepadAxis( "rightx" ) ),
            righty = joyMin( "righty", joystick:getGamepadAxis( "righty" ) ),
            triggerleft = joyMin( "triggerleft", joystick:getGamepadAxis( "triggerleft" ) ),
            triggerright = joyMin( "triggerright", joystick:getGamepadAxis( "triggerright" ) ),
            a = joystick:isGamepadDown( "a" ),
            b = joystick:isGamepadDown( "b" ),
            x = joystick:isGamepadDown( "x" ),
            y = joystick:isGamepadDown( "y" ),
            back = joystick:isGamepadDown( "back" ),
            guide = joystick:isGamepadDown( "guide" ),
            start = joystick:isGamepadDown( "start" ),
            leftstick = joystick:isGamepadDown( "leftstick" ),
            rightstick = joystick:isGamepadDown( "rightstick" ),
            leftshoulder = joystick:isGamepadDown( "leftshoulder" ),
            rightshoulder = joystick:isGamepadDown( "rightshoulder" ),
            dpup = joystick:isGamepadDown( "dpup" ),
            dpdown = joystick:isGamepadDown( "dpdown" ),
            dpleft = joystick:isGamepadDown( "dpleft" ),
            dpright = joystick:isGamepadDown( "dpright" ),
        }
        
        joy.id, joy.instanceid = joystick:getID()
        joy.name = joystick:getName()
        
        joy.vibrates = joystick:isVibrationSupported()
        if joy.vibrates then
            joy.vibration = joystick:getVibration()
        end
        
        joys[joystick] = joy
    end
end

function love.joystickremoved( joystick )
    joys[joystick] = nil
end

function love.gamepadaxis( joystick, axis, value )
    joys[joystick][axis] = joyMin( axis, value )
end

function love.gamepadpressed( joystick, button )
    joys[joystick][button] = true
    if button == "guide" then
        devPrint( joys[joystick] )
    end
end

function love.gamepadreleased( joystick, button )
    joys[joystick][button] = false
end
